﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading;
using System.IO;
using System.Drawing;
using Styx;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;
using Styx.Logic;
using Styx.Logic.Combat;
using Styx.Logic.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using TreeSharp;

namespace GUI
{
    class Classname : CombatRoutine
    {
        public override sealed string Name { get { return "Agonizing Soul (Affliction) v1.1"; } }
        public override WoWClass Class { get { return WoWClass.Warlock; } }
        private static LocalPlayer Me { get { return ObjectManager.Me; } }

        public DateTime _ua = DateTime.Now;
        public static WoWSpell ua = WoWSpell.FromId(30108);

        List<Stopwatch> debuffCooldowns;
        Stopwatch _corruption = new Stopwatch();
        Stopwatch _doom = new Stopwatch();
        Stopwatch _agony = new Stopwatch();
        Stopwatch _cote = new Stopwatch();


        #region Log
        private void slog(string format, params object[] args) //use for slogging
        {
            Logging.Write(format, args);
        }
        #endregion


        #region Initialize
        public override void Initialize()
        {
            Logging.Write(Color.White, "___________________________________________________");
            Logging.Write(Color.Crimson, "-------- Agonizing Soul v1.1 CC by Shaddar -------");
            Logging.Write(Color.Crimson, "-----  Remember to comment on the forum! --");
            Logging.Write(Color.Crimson, "-------- /like and +rep if you like this CC! ------");
            Logging.Write(Color.White, "___________________________________________________");
        }
        #endregion

        #region Settings

        public override bool WantButton
        {
            get
            {
                return true;
            }
        }

        public override void OnButtonPress()
        {

            GUI.Form1 f1 = new GUI.Form1();
            f1.ShowDialog();
        }
        #endregion

        #region StopWatch

        public override void Pulse()
        {
            if (debuffCooldowns == null)
            {
                debuffCooldowns = new List<Stopwatch>();
                debuffCooldowns.Add(_corruption);
                debuffCooldowns.Add(_doom);
                debuffCooldowns.Add(_agony);
                debuffCooldowns.Add(_cote);

            }
        }

        #endregion

        #region Rest

        public override bool NeedRest
        {
            get
            {
                if (WarlockSettings.Instance.FelArmor && !Me.Mounted && CastBuff("Fel Armor") && !(Me.ChanneledCastingSpellId == 79268))
                    if (CastSpell("Fel Armor") == true)
                        Thread.Sleep(7000);


                if (!Me.Mounted && !Me.GotAlivePet && !(Me.ChanneledCastingSpellId == 79268) && WarlockSettings.Instance.SummonPet)
                    Lua.DoString("RunMacroText('/cast Summon Felhunter');");
                Thread.Sleep(1000);

                if (WarlockSettings.Instance.DarkIntent && Me.Pet.IsAlive && !Me.Mounted && !Me.HasAura("Dark Intent") && !(Me.ChanneledCastingSpellId == 79268))
                    Lua.DoString("RunMacroText('/cast [@target,exists][@pet][] Dark Intent');");
                Thread.Sleep(1000);

                if ((Me.HealthPercent < 50 || Me.CurrentSoulShards < 3) && WarlockSettings.Instance.SoulHarvest)
                    if (CastSpell("Soul Harvest")) ;

                return false;
            }
        }

        public override void Rest()
        {

        }
        #endregion

        #region AOE
        public static bool Cast(string spellName, WoWPoint MeCurrentTargetLocation)
        {

            bool result = SpellManager.Cast(spellName);
            LegacySpellManager.ClickRemoteLocation(StyxWoW.Me.CurrentTarget.Location);
            return result;

        }
        #endregion

        #region Add Detection
        //Credit to CodeNameGamma for detectAdds code
        private List<WoWUnit> adds = new List<WoWUnit>();

        private List<WoWUnit> detectAdds()
        {
            if (Me.CurrentTarget != null)
            {
                List<WoWUnit> addList = ObjectManager.GetObjectsOfType<WoWUnit>(false).FindAll(unit =>
                            unit.Guid != Me.Guid &&
                            unit.Location.Distance(Me.CurrentTarget.Location) <= 13 &&
                            (unit.IsTargetingMyPartyMember || unit.IsTargetingMyRaidMember || unit.IsTargetingMeOrPet) &&
                            !unit.IsFriendly &&
                            !unit.IsPet &&
                            !Styx.Logic.Blacklist.Contains(unit.Guid));

                if (addList.Count > 1)
                {
                    Logging.Write(Color.Crimson, "Detected " + addList.Count.ToString() + " adds! Switchting to AoE mode!");
                }
                return addList;
            }
            else
            {
                return null;
            }

        }
        private bool IsTargetBoss()
        {
            string UnitClassification = Lua.GetReturnValues("local classification = UnitClassification(\"target\"); return classification")[0];
            string UnitLevel = Lua.GetReturnValues("local level = UnitLevel(\"target\"); return level")[0];
            if (!Me.IsInRaid)
            {
                if (UnitClassification == "worldboss" ||
                   (Me.CurrentTarget.Level == 87 && Me.CurrentTarget.Elite) && Me.CurrentTarget.MaxHealth >= 3500000 ||
                   (Me.CurrentTarget.Level == 89))
                    return true;

                else return false;
            }
            else
            {
                if (UnitLevel == "-1")
                    return true;

                else return false;
            }


        }
        #endregion

        #region CastSpell Method
        // Credit to Apoc for the below CastSpell code
        // Used for calling CastSpell in the Combat Rotation
        public bool CastSpell(string spellName)
        {
            if (SpellManager.CanCast(spellName))
            {
                SpellManager.Cast(spellName);
                // We managed to cast the spell, so return true, saying we were able to cast it.
                return true;
            }
            // Can't cast the spell right now, so return false.
            return false;
        }
        public bool CastBuff(string name)
        {
            if (!PlayerHasBuff(name) && SpellManager.CanBuff(name, Me))
            {
                SpellManager.Cast(name);
                slog(name);
                return true;
            }
            return false;
        }

        public bool PlayerHasBuff(string name)
        {
            return PlayerBuffTimeLeft(name) > 0;
        }

        public bool TargetHasDebuff(string name)
        {
            return TargetDebuffTimeLeft(name) != 0; // <0 means passive aura; >0 means active one
        }
        public double PlayerBuffTimeLeft(string name)
        {
            try
            {
                var lua = string.Format("local x=select(7, UnitBuff('player', \"{0}\", nil, 'PLAYER')); if x==nil then return 0 else return x-GetTime() end", Lua.Escape(name));
                var t = double.Parse(Lua.GetReturnValues(lua)[0]);
                return t;
            }
            catch
            {
                slog("Lua failed in AuraTimeLeft");
                return 999999;
            }
        }

        private double TargetDebuffTimeLeft(string DebuffName)
        {
            return double.Parse(Lua.GetReturnValues(string.Format("local expirationTime = select(7, UnitDebuff(\"target\", \"{0}\", nil, \"player\")); " +
                                     "if expirationTime == nil then return 0 else return expirationTime - GetTime() end", DebuffName))[0]);
        }

        public double TargetDebuffTimeLeftAll(string name)
        {
            try
            {
                var lua = string.Format("local x=select(7, UnitDebuff(\"target\", \"{0}\", nil)); if x==nil then return 0 else return x-GetTime() end", Lua.Escape(name));
                var t = double.Parse(Lua.GetReturnValues(lua)[0]);
                return t;
            }
            catch
            {
                slog("Lua failed in TargetAuraTimeLeft");
                return 999999;
            }
        }
        #endregion

        #region CombatStart


        private void AutoAttack()
        {
            if (!Me.IsAutoAttacking)
            {
                Lua.DoString("StartAttack()");
            }
        }
        #endregion

        #region Combat

        public override void Combat()
        {
            adds = detectAdds();
            foreach (Stopwatch s in debuffCooldowns)
            {
                if (s.Elapsed.Milliseconds >= 300)
                {
                    s.Stop();
                    s.Reset();
                }
            }
            if (Me.CurrentTarget != null && Me.CurrentTarget.IsAlive == true && Me.Mounted == false)
            {


                //////////////////////////////////////////////Cooldowns are here//////////////////////////////////////////////////////////////////////////////////////////////////

                {
                    if (WarlockSettings.Instance.DemonSoul &&
                        (IsTargetBoss() && TargetHasDebuff("Bane of Doom") && TargetHasDebuff("Corruption") ||
                        IsTargetBoss() && TargetHasDebuff("Bane of Agony") && TargetHasDebuff("Corruption")))
                        if (CastSpell("Demon Soul")) ;
                }
                {
                    if (WarlockSettings.Instance.DoomGuard && IsTargetBoss() && TargetHasDebuff("Bane of Doom") || IsTargetBoss() && TargetHasDebuff("Bane of Agony"))
                		if (CastSpell("Summon Doomguard"));
                }
                {
                    if (IsTargetBoss())
                    {
                        Lua.DoString("RunMacroText('/use 10');");
                    }
                }
                {
                    if (WarlockSettings.Instance.Trinket1 && IsTargetBoss())
                    {
                        Lua.DoString("RunMacroText('/use 13');");
                    }
                }
                {
                    if (WarlockSettings.Instance.Trinket2 && IsTargetBoss())
                    {
                        Lua.DoString("RunMacroText('/use 14');");
                    }
                }

                //////////////////////////////////////////////Racial Skills here//////////////////////////////////////////////////////////////////////////////////////////////////

                {
                    if (WarlockSettings.Instance.Berserking && IsTargetBoss())
                    {
                        Lua.DoString("RunMacroText('/Cast Berserking');");
                    }
                }
                {
                    if (WarlockSettings.Instance.BloodFury && IsTargetBoss())
                    {
                        Lua.DoString("RunMacroText('/Cast Blood Fury');");
                    }
                }

                ///////////////////////////////////////////////AoE Rotation here//////////////////////////////////////////////////////////////////////////////////////////////////

            }
            if (WarlockSettings.Instance.AOE && adds.Count >= 3 && Me.CurrentTarget != null && Me.CurrentTarget.IsAlive == true && Me.Mounted == false)
            {

                {
                    if (Me.CurrentTarget.Distance <= 10 && Me.IsCasting == false)
                    {
                        if (CastSpell("Shadowflame") == true)
                        {
                            Logging.Write(Color.Red, ">> Shadowflame <<");
                        }
                    }
                }
                {
                    if (Me.CurrentTarget.HealthPercent <= 10 && Me.ChanneledCastingSpellId == 27243)
                    {
                        Lua.DoString("RunMacroText('/Stopcasting');");
                        {
                            Lua.DoString("RunMacroText('/Targetenemy');");
                        }
                    }
                }
                {
                    if (!SpellManager.Spells["Soulburn"].Cooldown)
                    {
                        if (CastSpell("Soulburn")) ;
                    }
                }
                {
                    if (PlayerHasBuff("Soulburn"))
                    {
                        if (CastSpell("Seed of Corruption")) ;
                    }
                }
                {
                    if (CastSpell("Seed of Corruption")) ;
                    {
                        if (Me.ChanneledCastingSpellId == 27243)
                        {
                            Lua.DoString("RunMacroText('/Targetenemy');");
                        }
                    }
                }


                ///////////////////////////////////////////Single Target DPS here/////////////////////////////////////////////////////////////////////////////////////////////////

            }
            if (adds.Count <= 2 && Me.CurrentTarget != null && Me.CurrentTarget.IsAlive == true && Me.Mounted == false)
            {
                {
                    if (Me.ChanneledCastingSpellId == 1120 && TargetDebuffTimeLeft("Drain Soul") <= 9 && (TargetDebuffTimeLeft("Haunt") <= 4 || TargetDebuffTimeLeft("Unstable Affliction") <= 3))
                    {
                        Lua.DoString("RunMacroText('/stopcasting');");
                    }
                }
                {
                    if (!IsTargetBoss() && Me.CurrentTarget.HealthPercent <= 10 && TargetHasDebuff("Unstable Affliction") && TargetHasDebuff("Corruption") && (TargetHasDebuff("Bane of Agony") || TargetHasDebuff("Bane of Doom")))
                    {
                        if (CastSpell("Soul Swap")) ;
                    }
                }
                {
                    if (Me.Auras.ContainsKey("Soul Swap") && Me.CurrentTarget.HealthPercent >= 10 && !TargetHasDebuff("Unstable Affliction") && !TargetHasDebuff("Corruption") && (!TargetHasDebuff("Bane of Agony") || !TargetHasDebuff("Bane of Doom")))
                    {
                        if (CastSpell("Soul Swap")) ;
                    }
                }
                {
                    if (!_cote.IsRunning && TargetDebuffTimeLeftAll("Curse of the Elements") <= 2 && TargetDebuffTimeLeftAll("Lightning Breath") <= 2 && TargetDebuffTimeLeftAll("Fire Breath") <= 2 && TargetDebuffTimeLeftAll("Earth and Moon") <= 2 && TargetDebuffTimeLeftAll("Ebon Plaguebringer") <= 2 && TargetDebuffTimeLeftAll("Master Poisoner") <= 2)
                    {
                        if (CastSpell("Curse of the Elements") == true)
                            _cote.Start();
                    }
                }
                {
                    if (!PlayerHasBuff("Soul Swap") && TargetDebuffTimeLeft("Unstable Affliction") <= 3)
                    {
                        if (_ua.AddMilliseconds(ua.CastTime + 700) < DateTime.Now)
                        {
                            _ua = DateTime.Now;
                            if (CastSpell("Unstable Affliction")) ;
                            return;
                        }
                    }
                }
                {
                    if (TargetDebuffTimeLeft("Haunt") <= 4)
                    {
                        if (CastSpell("Haunt")) ;
                    }
                }
                {
                    if (PlayerHasBuff("Shadow Trance"))
                    {
                        if (CastSpell("Shadow Bolt")) ;
                    }
                }
                {
                    if (!PlayerHasBuff("Soul Swap") && TargetDebuffTimeLeft("Corruption") <= 3 && !_corruption.IsRunning)
                    {
                        if (CastSpell("Corruption") == true)
                            _corruption.Start();
                    }
                }
                {
                    if (!PlayerHasBuff("Soul Swap") && IsTargetBoss() && Me.CurrentTarget.HealthPercent > 20 && !TargetHasDebuff("Bane of Doom") && !_doom.IsRunning)
                    {
                        if (CastSpell("Bane of Doom") == true)
                            _doom.Start();
                    }
                }
                {
                    if (!PlayerHasBuff("Soul Swap") && IsTargetBoss() && Me.CurrentTarget.HealthPercent < 20 && TargetDebuffTimeLeft("Bane of Agony") <= 4 && !_agony.IsRunning ||
                    !PlayerHasBuff("Soul Swap") && !IsTargetBoss() && TargetDebuffTimeLeft("Bane of Agony") <= 4 && !_agony.IsRunning)
                    {
                        if (CastSpell("Bane of Agony") == true)
                            _agony.Start();
                    }
                }
                {
                    if (Me.CurrentTarget.Distance <= 10 && Me.IsCasting == false)
                    {
                        if (CastSpell("Shadowflame") == true)
                        {
                            Logging.Write(Color.Red, ">> Shadowflame <<");
                        }
                    }
                }
                {
                    if (IsTargetBoss() && Me.CurrentTarget.HealthPercent >= 25 && (TargetHasDebuff("Bane of Doom") || TargetDebuffTimeLeft("Bane of Agony") >= 4) && TargetDebuffTimeLeft("Haunt") >= 4 && TargetDebuffTimeLeft("Corruption") >= 3 && TargetDebuffTimeLeft("Unstable Affliction") >= 3)
                        if (CastSpell("Shadow Bolt")) ;
                }
                {
                    if (!IsTargetBoss() && Me.CurrentTarget.HealthPercent >= 25 && TargetDebuffTimeLeft("Drain Life") <= 2 && (TargetHasDebuff("Bane of Doom") || TargetDebuffTimeLeft("Bane of Agony") >= 4) && TargetDebuffTimeLeft("Haunt") >= 4 && TargetDebuffTimeLeft("Corruption") >= 3 && TargetDebuffTimeLeft("Unstable Affliction") >= 3)
                        if (CastSpell("Drain Life")) ;
                }
                {
                    if (Me.CurrentTarget.HealthPercent <= 25 && (TargetHasDebuff("Bane of Doom") || TargetDebuffTimeLeft("Bane of Agony") >= 4) && TargetDebuffTimeLeft("Haunt") >= 4 && TargetDebuffTimeLeft("Corruption") >= 3 && TargetDebuffTimeLeft("Unstable Affliction") >= 3)
                        if (CastSpell("Drain Soul")) ;
                }
                {
                    if (Me.ManaPercent < 30)
                        if (CastSpell("Life Tap")) ;
                }


                ////////////////////////////////////////////Moving Rotation here /////////////////////////////////////////////////////////////////////////////////////////////////

                {
                    if (Me.IsMoving == true && Me.ManaPercent < 70)
                        if (CastSpell("Life Tap")) ;
                }
                {
                    if ((TargetHasDebuff("Bane of Doom") && TargetHasDebuff("Corruption") ||
                        TargetHasDebuff("Bane of Agony") && TargetHasDebuff("Corruption")) && Me.IsMoving)
                    {
                        Lua.DoString("RunMacroText('/cast Fel Flame');");
                    }
                }

                //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

            }

        }

        #endregion

    }
}